<Cabbage>
form caption("Presets") size(370, 280), colour(58, 110, 182), pluginid("MPre")
rslider bounds(12, 8, 85, 79), channel("att"), range(0, 1, 0.01), text("Att.")
rslider bounds(98, 8, 85, 79), channel("dec"), range(0, 1, 0.4), text("Dec.")
rslider bounds(184, 8, 85, 79), channel("sus"), range(0, 1, 0.7), text("Sus.")
rslider bounds(270, 8, 85, 79), channel("rel"), range(0, 1, 0.8), text("Rel.")

filebutton bounds(12, 190, 60, 28), channel("saveFile"), text("Save"), populate("*.pres","presets"), mode("save")
filebutton bounds(74, 190, 60, 28), channel("openFile") text("Open"), populate("*.pres"), mode("file")

label bounds(14, 108, 336, 11) text("<No Preset>") identchannel("PresetName")
listbox bounds(170, 142, 180, 132) populate("*.pres","presets") channel("box") channeltype("string") identchannel("boxI")
button bounds(74, 220, 60, 28), channel("reload") text("reload")
</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-n -d -+rtmidi=NULL -M0 --midi-key-cps=4 --midi-velocity-amp=5
</CsOptions>
<CsInstruments>
; Initialize the global variables. 
sr = 44100
ksmps = 32
nchnls = 2
0dbfs = 1
gSFileName init 0

;always on and listening for preset updates..
instr 1000
    if changed:k(chnget:S("openFile")) == 1 then
        gSFileName chnget "openFile"
        gSspecificDelim = "/"
        event "i", 1002, 0, .1
    endif

    if changed:k(chnget:S("box")) == 1 then
        gSFileName chnget "box"
        gSspecificDelim = "\\"
        event "i", 1002, 0, .1
    endif   
    
    if changed:k(chnget:S("saveFile")) == 1 then
        event "i", 1003, 0, .1
    endif
    
    if changed:k(chnget:k("reload")) == 1 then
        event "i", 1002, 0, .1
    endif
endin

;================================================




instr 1002 ;restore presets
    

    if strrindex(gSFileName, ".pres") == -1 then
        gSFileName strcat gSFileName, ".pres"
    endif
    
     istrlen    strlen   gSFileName
    
    idelimiter strrindex gSFileName, gSspecificDelim
    S2    strsub gSFileName, idelimiter + 1, istrlen  ; "String2"
    idelimiter strrindex S2, "."
    S3 strsub S2, 0, idelimiter
    Smessage sprintfk "text(%s)",S3
    chnset Smessage, "PresetName"
    
    
    
    i1, i2, i3, i4 init 0
    fini gSFileName, 0, 0, i1, i2, i3, i4
    chnset i1, "att"
    chnset i2, "dec"
    chnset i3, "sus"
    chnset i4, "rel"
endin

;================================================
instr 1003 ;save presets
    gSFileName chnget "saveFile"

    if strrindex(gSFileName, ".pres") == -1 then
        gSFileName strcat gSFileName, ".pres"
    endif

    fprints gSFileName, "%f %f %f %f", chnget:i("att"), chnget:i("dec"), chnget:i("sus"), chnget:i("rel")
    ficlose gSFileName
endin

</CsInstruments>
<CsScore>
;causes Csound to run for about 7000 years...
i1000 0 z
</CsScore>
</CsoundSynthesizer>